
/*
 * CS5600 University of Utah
 * Charles McGarvey
 * mcgarvey@eng.utah.edu
 */

#ifndef __SCENE_H__
#define __SCENE_H__

#include "pixmap.h"


/*
 * A scene.
 */
typedef struct scene scene_t;

/*
 * Allocate a scene by reading in data from a file.
 */
scene_t* scene_alloc(const char* filename);

/*
 * Destroy a scene.
 */
void scene_destroy(scene_t* s);


/*
 * Render a scene to an in-memory pixmap.  The caller takes ownership of the
 * returned object and must destroy it when it is no longer needed.
 */
pixmap_t* scene_render(scene_t* s);


#endif // __SCENE_H__

